// skipper 3 9 Jan 2002
// input wordlist.txt + cluster membership.txt + inverted entries as a binary file
// output new wordlist file.txt (where postings sizes are increased) and
//        binary inverted entires with skips
// observation: for now list sizes are doubled, but could perform better
// when clusters are not random!
// Not, son bloklarda pointer -1, yani no more clusters demek
// entry bi arraye alinica cluster pointerlari bi sonraki cluster nodeun array indexine
// isaret ediyor...


// burada skip inv indexi cok naive bi sekilde implement edecegim: yani eski
// indexi okuyup doclari clusterlara gore sort edip baslarina cluster info koyup
// geri yazacagim... cok hamal yaani...


// 9 jan: asagidakilerden bazilari (en azindan su narrative vb meselesi okulda
// hallolmus idi, bi bakalim...

// FS1; system for rankin querying
// pek cok sabit var, definelara dikkat et
// bazen gocuyo, tahminim blank line handle ederken olabilir...check et
// su an title+ desc + narr hanle ediyo
// TBD:
// 1) su short - long icin handling i ekle: hangi tagleri process edelim
// 2) bsearch not found bi saydir. kac case
// 3) boolean impement et!


// indexer5.c: read wordlist with CFC values
// compute tf*CFC for doc terms, normalize them and THEN add to index
// to do this, change index entries to be double, and add index function, too
// wordlist, entry ve dvector structurelara weight fieldi eklndi
// CFC weight wordlistten okuyup, term weighti tf*cfc oarak buluyo, dvece kaydediyo
// sonra dvec normalize edilip her bir term icin doc_id+weight_in_doc
// inveted indexe yaziliyo... Print alinan yerlerde falan da duzeltme oldu tabii
// CFC degisirse burada bi sey yapma. Tf veya nc degisirse bu kodda duzeltme gerekir
// unutma,son dvec outputa looptan sonra yazildigi icn 2 yerde duzeltme gerekiyo...

// indexer 3;
// read Wordlist file, read document vector, create the inverted index and
// write to a binarty file. Inverted entry lengths are known apriori.
// In this version, I'll use direct file access, mnext I'll use mem_map
// ONEMLI: Tum islemlerde index 1 den basliyo!!!!!!!!

// simdi mem_map yapabiliriz...
// large scalede bi deneyelim, unutma array length degisebilir
// tum document mem de tutuluyo degisik weighting kullanirsak diye...

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include <time.h> // sys vb. okul icin... see rfp
//#include <stem1.h>
//#include "f:\ir\project\inverted\btrie.h"
#include "btrie.h"

#include "sglobal.h"

typedef struct vec {
       int index;
       double weight;
       } *VP, VectorComp;


typedef struct vec2 {
      VectorComp VecElement[1];
      int nonzero_elements;
      } Vector;



typedef struct doc_ve {
        long int index;
        char word[70];
        long int rank_in_doc;
        double term_weight; //INDEXER5
        long int address; // address of where to start reading;
        } DocVec, *DV;


typedef struct rec {
        char TName [1];
        char Cont_field [1];
        //char TDom [100];
        //char TSource [10];
        char tokens [1][3]; // to keep tokens in memory after tokenizing
        int token_no;
        char dc_token[1];

        double importance; // topic, source importance value
        double propogate_val; // here max. sim * importance but in general
        Vector *v;
        } *TP, Tuple;

typedef struct inv_ent {
        int doc_id;
        //int freq_in_doc;
        double weight;
        } InvEntry;

// In this version, I keep only the necessary structures for each word:
// namely; a_Word, occurrs_in_docs, CFCweight and disk_address

typedef struct words {
        char a_word[TOKEN_SIZE]; // for handling queries
        int occurs_in_docs; // to retrieve inv entires and also weight queries
        long int disk_address; // address to access in binary file
        double CFCweight; // CFC weight of the word
        } *WP, Word;

struct timeval *start_t, *end_t;
int elapsed_time;
struct timezone *tz;


Tuple rel_R [1]; // in these arrays assume keeping 2000 tuples of each relation
Tuple rel_S [1];

//Result Result_rel [1];

Word WordList[WORD_NO];
InvEntry buffer[BUFFERSIZE];

long int max_R, max_S; // no of tuples in R and S

int no_of_matches; // no of joined tuples
int no_of_comparisons; // no of compared tuples

double match_threshold = 0.5;

// these are here because i am so stupid that i could not pass them as arguments
double score;
int found = 0;
int word_no_in_list=0;

char stopwords[NOSTOPWORD][50] ; // to keep stop words

//double Vector1[WORD_NO]; // SIM9: will represent two tuples
//double Vector2[WORD_NO];

Vector *Vector1;
Vector *Vector2;

DocVec DVector[DOC_SIZE]; // to keep all term in a doc with dublications
int d_size=0; // length of current doc

long int doc_no = 0; // total no_of docs in all files


int trie_start = 0;
int err=0;

FILE * ifp, *j_ifp, *eval_out, *ICMfile;
FILE * out, *d_out, *err_out, *out_2, *entry_out, *entry_ifp;

char tName2[300];

int processing_R = 1;
int processing_S = 0;

char final_tokens [TOKEN_NO][TOKEN_SIZE];

typedef struct res {
        int doc_index;
        double sim_rank;
        } Result, *RP;


Result accumulator[DOC_NUM]; // accumulator array for partial similarities

// to keep top results found for each query
Result results [QUERY_NO][TOP_N];
Result temporary [TOP_N];

// to keep relevant results
int relevants[RELEVANT_SIZE];

// jan 9
typedef struct cluster_lists {
        int docs_in_cluster;
        int current;
        InvEntry *ClusterDocs;
        } CDtype; // this would keep the docs for each cluster in an entry
// modified
CDtype CD[NC+1];

// the structure will be initialized by reading a file, I hope
typedef struct inverted_cluster_membership {
         int clusters_doc_in;
         int *cluster_list;
         } ICMtype; //for each doc an array that includes the cluster list for this document

ICMtype ICM[DOC_NUM];

int no_of_clusters_found = 0;
// can be a list perhaps;
int clusters_found[NC];

InvEntry grand_temp_buffer[CLUS_SIZE_IN_LIST * NC];


// jan 9
/*
void clean_ClusterDocs()
{
   int i;

   for (i=0; i<NC; i++)
   {
       free(ClusterDocs[i]);
       ClusterDocs[i] = NULL;
   }

}
  */
void initialize_ClusterDocs()
{
 int i;

 for (i=0; i<NC; i++)
  {
      CD[i].ClusterDocs = NULL;
      CD[i].current = 0;
      CD[i].docs_in_cluster = 0;
  }
}




int index_order(DV dvec1, DV dvec2)
{
   if (dvec1->index > dvec2->index)
      return 1;
   if (dvec1->index < dvec2->index)
      return -1;
   return 0;
}


int lex_order3(WP w1, WP w2)
{
  return strcmp(w1->a_word, w2->a_word);
}


void process_entries()
{
 int i, j, k, p, b, counter;
 long int address;
 int cluster_id;
 int d_id;
 InvEntry temp_buffer[CLUS_SIZE_IN_LIST];

 int grand_counter = 0;
 int grand_size = 0;

 long int start_address = 0;
 int start_index = 0;

 // i starts from 1, just like the WordList itself




 for (i=1; i<word_no_in_list; i++)
 {
   printf("processing list %d\n", i);

   // read the original inv entry
   address = WordList[i].disk_address;
   fseek(entry_ifp, address, 0);
   fread(buffer, sizeof(InvEntry), WordList[i].occurs_in_docs, entry_ifp);


   /*
   if (i==1)
    {
    //   fprintf(out, "word);
   for(b=0; b<WordList[i].occurs_in_docs; b++)
     fprintf(out, "%d d_id %d weight %lf\n", b, buffer[b].doc_id, buffer[b].weight);
    }
    */

   // for each doc in the list
   no_of_clusters_found = 0;


   for (j=0; j<WordList[i].occurs_in_docs; j++)
     {
        // for each cluster that this document belongs to
        for (k=0; k< (ICM[buffer[j].doc_id].clusters_doc_in); k++)

        {
         cluster_id = ICM[buffer[j].doc_id].cluster_list[k];

         if (CD[cluster_id].ClusterDocs==NULL)
            {
            CD[cluster_id].ClusterDocs = (InvEntry *) malloc(sizeof(InvEntry)*CLUS_SIZE_IN_LIST);
            CD[cluster_id].current = 0;
            CD[cluster_id].docs_in_cluster = 0;
            no_of_clusters_found++;
            }

         if (CD[cluster_id].current > CLUS_SIZE_IN_LIST)
         {
            printf("error in list size for the cluster\n");
            exit(1);
         }

         // insert the doc to the corresponding cluster list
         CD[cluster_id].ClusterDocs[CD[cluster_id].current].doc_id = buffer[j].doc_id;
         CD[cluster_id].ClusterDocs[CD[cluster_id].current].weight = buffer[j].weight;
         CD[cluster_id].current ++;
         CD[cluster_id].docs_in_cluster++;

        } // inermost for

      } //second for


      //fprintf(out, "posting list: %d, cluster no is %d\n",i, no_of_clusters_found);
      // now I inserted each doc in this posting list to its cluster list(s)
      // so, i can merge them and write back to the output file
      counter = 1;
      grand_size = 0;
      for (k=0; k<NC+1; k++)
      {
         if (CD[k].ClusterDocs!=NULL)
         {

         //create temp_buffer
         //i don think i need this!!!
         /*
         for (p=0; p<CLUS_SIZE_IN_LIST; p++)
             {
              temp_buffer[p].doc_id=0;
              temp_buffer[p].weight = 0.0;
             }
        */

         temp_buffer[0].doc_id = k; //keeps cluster id

         if (counter != no_of_clusters_found)
            //temp_buffer[0].weight = (double) start_address + sizeof(InvEntry)*CD[k].current+1; // keeps next cluster group address or just -1 to signal an end
            {
             temp_buffer[0].weight = (start_index + CD[k].current+1);
             start_index = temp_buffer[0].weight;
            }

         else
             {
             temp_buffer[0].weight = -1; //the last cluster group
             //printf("here\n");
             }

         grand_temp_buffer[grand_size].doc_id = k; //keeps cluster id
         grand_temp_buffer[grand_size].weight= temp_buffer[0].weight;

         for (p=0; p<CD[k].current; p++)
         {
            temp_buffer[p+1].doc_id = CD[k].ClusterDocs[p].doc_id;
            grand_temp_buffer[grand_size +p+1].doc_id = CD[k].ClusterDocs[p].doc_id;

            temp_buffer[p+1].weight = CD[k].ClusterDocs[p].weight;
            grand_temp_buffer[grand_size + p+1].weight = CD[k].ClusterDocs[p].weight;

         }




         /*
         fseek(entry_out,start_address, 0);
         fwrite(temp_buffer,sizeof(InvEntry),CD[k].current+1, entry_out);
         */


         counter++;

         //start_address += sizeof(InvEntry)*(CD[k].current+1);
         grand_size += CD[k].current+1;

         /*
         if (i==1)
          {
            fprintf(out, "cluster no %d cluster size %d current grand size %d\n", k,CD[k].current, grand_size
            );

          }
          */

         //fprintf(out, "start add %ld\n", start_address);

         // now clean the array so that we find it clean next time
         free(CD[k].ClusterDocs);
         CD[k].ClusterDocs = NULL;
         CD[k].current = 0;
         CD[k].docs_in_cluster=0; // is this field unnecessary?

         } // big if

      } // second k-loop


 fseek(entry_out,start_address, 0);
 fwrite(grand_temp_buffer,sizeof(InvEntry),grand_size, entry_out);

/*if (i==1)
{
//   fprintf(out, "word);
   for(b=0; b<grand_size; b++)
     fprintf(out, "%d d_id %d weight %lf\n", b, grand_temp_buffer[b].doc_id,grand_temp_buffer[b].weight);
}*/

 start_address += (grand_size*sizeof(InvEntry));

 //fprintf(out, "counter is %d\n", counter);
 start_index = 0;


// WordList[i].occurs_in_docs += no_of_clusters_found; // i.e. next time, all posting
 WordList[i].occurs_in_docs = grand_size; // i.e. next time, all posting

 /*if (i==1)
{
  fprintf(out, "occrus %d grand %d %d\n", WordList[i].occurs_in_docs, grand_size, no_of_clusters_found);
  fflush(out);
  exit(1);

}*/
 //lists will be longer,so we need to write this new wordlist out as well!!!

 // Note that, the disk addresses after this procedure are Not correct anymore
 // and need to be recalculated

 }// outer_for

} //func


int ord_ordering (int * p, int * q)
{
  if (*p > *q)
     return 1;
  if (*p < *q)
     return -1;
  return 0;
}

int
random_int (int max) /* return a random integer in [0,max) */
{
  if (max == 0) return (0);
  return (random()%max);
} /* random_int */


rand_ICM()
{
 int i;

  out = fopen("rand.txt", "wt");

 for (i=1; i<DOC_NUM; i++)
 {
   ICM[i].clusters_doc_in= 1; // assume each doc appears in 1 cluster
   ICM[i].cluster_list = (int *) malloc(sizeof(int)*ICM[i].clusters_doc_in);
   ICM[i].cluster_list[0] = random_int(100); // give a random cluster no
   fprintf(out,"doc %d cluster %d\n", i, ICM[i].cluster_list[0]);
   fflush(out);
 }

 fclose(out);

}

rand_ICM2()
{
   ICM[1].clusters_doc_in= 1; // assume each doc appears in 1 cluster
   ICM[1].cluster_list = (int *) malloc(sizeof(int)*ICM[1].clusters_doc_in);
   ICM[1].cluster_list[0] = 1; // give a random cluster no

   ICM[2].clusters_doc_in= 1; // assume each doc appears in 1 cluster
   ICM[2].cluster_list = (int *) malloc(sizeof(int)*ICM[2].clusters_doc_in);
   ICM[2].cluster_list[0] = 2; // give a random cluster no

   ICM[3].clusters_doc_in= 1; // assume each doc appears in 1 cluster
   ICM[3].cluster_list = (int *) malloc(sizeof(int)*ICM[3].clusters_doc_in);
   ICM[3].cluster_list[0] = 3; // give a random cluster no

   ICM[4].clusters_doc_in= 1; // assume each doc appears in 1 cluster
   ICM[4].cluster_list = (int *) malloc(sizeof(int)*ICM[4].clusters_doc_in);
   ICM[4].cluster_list[0] = 4; // give a random cluster no

   ICM[5].clusters_doc_in= 1; // assume each doc appears in 1 cluster
   ICM[5].cluster_list = (int *) malloc(sizeof(int)*ICM[5].clusters_doc_in);
   ICM[5].cluster_list[0] = 2; // give a random cluster no

   ICM[6].clusters_doc_in= 1; // assume each doc appears in 1 cluster
   ICM[6].cluster_list = (int *) malloc(sizeof(int)*ICM[6].clusters_doc_in);
   ICM[6].cluster_list[0] = 3; // give a random cluster no

   ICM[7].clusters_doc_in= 1; // assume each doc appears in 1 cluster
   ICM[7].cluster_list = (int *) malloc(sizeof(int)*ICM[7].clusters_doc_in);
   ICM[7].cluster_list[0] = 1; // give a random cluster no

   ICM[8].clusters_doc_in= 1; // assume each doc appears in 1 cluster
   ICM[8].cluster_list = (int *) malloc(sizeof(int)*ICM[8].clusters_doc_in);
   ICM[8].cluster_list[0] = 1; // give a random cluster no

   ICM[9].clusters_doc_in= 1; // assume each doc appears in 1 cluster
   ICM[9].cluster_list = (int *) malloc(sizeof(int)*ICM[9].clusters_doc_in);
   ICM[9].cluster_list[0] = 2; // give a random cluster no

   ICM[10].clusters_doc_in= 1; // assume each doc appears in 1 cluster
   ICM[10].cluster_list = (int *) malloc(sizeof(int)*ICM[10].clusters_doc_in);
   ICM[10].cluster_list[0] = 3; // give a random cluster no

}

void process_ICM(char * relname)
{
   int i, j;
   int doc_id;
   int no_of_clus; // the number of clusters that doc is in

   //open file
   if (!(ICMfile = fopen(relname,"rt")))
   {
      printf("file not found!\n");
      exit(1);
   }

   // Again, remember docs start from 1
   for (i=1; i<DOC_NUM; i++)
   {
      fscanf(ICMfile, "%d %d", &doc_id, &no_of_clus);
      if (i!= doc_id)
      {
         printf("something is wrong!!\n");
         exit(1);
      }


      ICM[i].clusters_doc_in = no_of_clus;
      //fprintf(out, "Doc %d is in %d clusters: ", i,ICM[i].clusters_doc_in);

      ICM[i].cluster_list = (int *) malloc(sizeof(int)*ICM[i].clusters_doc_in);
      for (j=0; j<no_of_clus; j++)
      {
         fscanf(ICMfile, " %d", &(ICM[i].cluster_list[j]));
         //fprintf(out, "%d ",ICM[i].cluster_list[j]);
      }
      //fprintf(out, "\n");
   } // outer loop

   fclose (ICMfile);
}

main() //(int argc,char *argv[])
{
  int i,j,k, t;
  char file_name[15], file_name2[15];
  char *f,*r, *m, pre, end;
  int FileNumber[13];
  int file_index;
  char line[MAX_TUPLE_LENGTH];
  char str[TOKEN_SIZE];
  int rank;

  long int address;

  /*
  if (argc!= 2)
  {
    printf("Usage: <exe_name> <window_size>\n");
    exit(0);
  } */

    // ***I do this here as I will process multi-file
  out = fopen("skip-log.txt", "wt");


  //rand_ICM();
  //rand_ICM2();
  process_ICM("ICM.txt");


  printf("skipped index creator v1.0\n");

  //err_out = fopen("indexer-logs.txt", "wt");

   // initialize WordList
   // well I do not need to do that, as I handle it while reading
   // In this version, I keep only the necessary structures for each word:
   // namely; a_Word, occurrs_in_docs, CFCweight and disk_address


  //open file
  if (!(ifp = fopen("wordlist.txt","rt")))
  {
      printf("file not found!\n");
      exit(1);
  }

  // DIKKAT: index 1 den basliyor effectively
  word_no_in_list=1;

  while (!feof(ifp))
  {
      // wordlist format <string blank occurrence_no blank CFCweight eol>

      fscanf (ifp, "%s %d %lf\n", str, &(WordList[word_no_in_list].occurs_in_docs), &(WordList[word_no_in_list].CFCweight)); //&rank);
      strcpy(WordList[word_no_in_list].a_word, str);

      if (word_no_in_list>1)
         WordList[word_no_in_list].disk_address =WordList[word_no_in_list-1].disk_address+(sizeof(InvEntry)*WordList[word_no_in_list-1].occurs_in_docs);
      else
         WordList[word_no_in_list].disk_address = 0;

      word_no_in_list++;

  }

  fclose(ifp);

  // here word_no_in_list-1 as I start from 1
  printf("i initialized the word list with %d words, guys\n", word_no_in_list-1);


  // initialize doc_vector
  // Currently, I am keeping this as an extra structure
  //initialize_doc_vec(DOC_SIZE);

  //in reality, read CM info from a file of course
  //rand_ICM();

  initialize_ClusterDocs();


  //open original inverted index file
  if (!(entry_ifp = fopen("entry.txt","rb")))
  {
      printf("file not found!\n");
      exit(1);
  }

  //open skipped inverted entry file to write...
  if (!(entry_out = fopen("skipped.txt","wb")))
  {
      printf("file not found!\n");
      exit(1);
  }

  // process inverted entries and create new file
  process_entries();



  fclose(entry_ifp);
  fclose(entry_out);
  fclose(out);

  // print out the new world list as it will be used with the new skipped index

  printf("finished processing\n");

  out = fopen("newwords.txt", "wt");
  i=1;
  while (i<word_no_in_list)
  {
        fprintf(out, "%s %d %lf\n",WordList[i].a_word, WordList[i].occurs_in_docs, WordList[i].CFCweight);
        fflush(out);
        i++;
  }

  fflush(out);

  fclose (out);


}
